package infomat.vectorspace.ordering;

import infomat.vectorspace.*;

import java.util.*;


/**
 * A convenience class for sorting.
 *
 * @version          080418
 * @author           Magnus Rosell
 */
public class IObjectFloatSorter{
	
    private MapEntryComparator mapEntryComparator = 
	new MapEntryComparator();

	
    public Vector<Map.Entry<IObject, Float>> 
	sort(HashMap<IObject, Float> map){
    	
    	Vector<Map.Entry<IObject, Float>> sorted = 
	    new Vector<Map.Entry<IObject, Float>>(map.entrySet());
    	Collections.sort(sorted, mapEntryComparator);
    	
    	return sorted;
    }

    
    
	
    /**
     * A private class that is used to order MapEntry:s.
     */
    private class MapEntryComparator implements Comparator{

	/**
	 * Compares two IObject:s and returns 1, 0 or -1 
	 *
	 * @param  o1 a IObject
	 * @param  o2 a IObject
	 * @return int 
	 */
	public int compare(Object o1, Object o2) {
	    float value1 = (Float)((Map.Entry)o1).getValue();
	    float value2 = (Float)((Map.Entry)o2).getValue();
	    // Strst frst
	    if(value1<value2)
		return 1;
	    else if (value1>value2)
		return -1;
	    else
		return 0;
	}    

    }



}

