package infomat.view;

import infomat.view.info.*;
import infomat.view.grouping.*;
import infomat.view.menu.*;

import javax.swing.*;

import java.awt.*;

/**
 * The Panel with all controls for a specific session.
 */
public class SessionPanel extends JPanel {

    private InfomatModel model;
    private InfomatView view;
	
    private JPanel mainPanel;

    private ToolbarView toolbarView;
    private ToolbarController toolbarController;

    //private boolean showInfoPanel=true;
    private boolean showGroupingPanel=true;
    private GroupingPanel groupingPanel;
	
	
    public final static Dimension PREFERRED_SESSION_DIMENSION = 
	new Dimension(800, 500);
	
    public InfomatView getInfomatView(){
	return view;
    }

    /** Toggle if the toolbar should be visible or hidden */
    public void toggleToolbar() {
	toolbarView.setVisible(!toolbarView.isVisible());
    }

    /*
      public void toggleInfoPanel(){
      showInfoPanel=!showInfoPanel;
      putAll();
      model.update();
      }
    */

    public void toggleGroupingPanel(){
	showGroupingPanel=!showGroupingPanel;
	putAll();
	model.update();
    }

    public void toggleOverview(){
	view.toggleOverview();
    }

    /*
    public void togglePixelInfo(){
	view.togglePixelInfo();
    }
    */

    public ToolbarController getToolbarController(){
	return toolbarController;
    }

    public ToolbarView getToolbarView(){
	return toolbarView;
    }
	
    /**
     * Create the SessionPanel
     */
    public SessionPanel(InfomatModel model) {
	//super(new BorderLayout());
	//	super(new GridLayout(3,1));

	this.model = model;
	setPreferredSize(PREFERRED_SESSION_DIMENSION);

	mainPanel = new JPanel(new BorderLayout());
	view = new InfomatView(model);
	toolbarController = new ToolbarController(view);
	toolbarView = new ToolbarView(toolbarController, model);
	//toolbarView.setLayout(new BoxLayout(toolbarView, BoxLayout.X_AXIS));
	view.setToolbarView(toolbarView);
		
	/*
	  infoPanel = new InfoPanel(model, view);
	  view.setInfoPanel(infoPanel);
	*/
	System.out.println("Lgger till InfomatView som observer till InfomatModel.");
	model.addObserver(view);
		
	groupingPanel = 
	    new GroupingPanel(model, view);
	/*
	  Dimension gspDim = new Dimension(800, 60);
	  groupingPanel.setPreferredSize(gspDim);
	  groupingPanel.setMinimumSize(gspDim);
	  groupingPanel.setMaximumSize(gspDim);
	*/
	model.addObserver(groupingPanel);

	//		OpacityView opacityView = 
	//		new OpacityView(new OpacityController(view), 50);
	//		mainPanel.add(opacityView, BorderLayout.WEST);
	mainPanel.add(view, BorderLayout.CENTER);


	putAll();
    }

    public void putAll(){
	removeAll();
	add(toolbarView); 
	/*
	  if(showInfoPanel)
	  add(infoPanel);
	*/
	if(showGroupingPanel)
	    add(groupingPanel);
	add(mainPanel); 
	repaint();
    }
	
	
    // Returns our InfomatView */
    // protected InfomatView getInfomatView(){
    // return view;
    // }
}
