package mro.util;

import java.io.*; 
import java.util.*; 

/**
 * Used to reduce tha amount of memory used when storing several
 * file names with one or several similar paths.
 *
 * @version          080212
 * @author           Magnus Rosell
 */
public class CommonPath{

    HashMap<String, String> map = new HashMap<String, String>();
    String sep = "\\\\/"; //File.separator;

    /**
     * Returns the path (index 0) and file name (1) parts from 
     * an entire file name.
     * The former is stored here to reduce the amount of memory used
     * to represent file names with common paths.
     */
    public Vector<String> getPathAndFileName(String fileName){
	
	String[] parts = fileName.split("["+sep+"]");
	String file = parts[parts.length-1];
	String newPath ="";
	for(int i=0; i<parts.length-1; i++){
	    newPath += parts[i]+File.separator;
	}
	String path = map.get(newPath);
	if(path==null){
	    path = newPath;
	    map.put(path, path);
	}
	
	Vector<String> ret = new Vector<String>();
	ret.add(path);
	ret.add(file);
	return ret;
    }


    public String getLargestCommonPath(){
	String largest = null;
	Iterator<String> it = map.keySet().iterator();
	while(it.hasNext()){
	    String next = it.next();
	    if(largest==null)
		largest=next;
	    largest = commonStart(largest, next);
	}
	if(largest.length()==0)
	    return null;
	return largest;
    }

    public static String commonStart(String p1, String p2){
	String ret = "";
	for(int i=0; i<p1.length() && i<p2.length(); i++){
	    if(p1.charAt(i)==p2.charAt(i))
		ret = ret + p1.charAt(i);
	}
	return ret;
    }

    /*
    public static String commonStart(String p1, String p2){
	String ret = "";
	String[] parts1 = p1.split("["+File.separator+"]");
	String[] parts2 = p2.split("["+File.separator+"]");

	for(int i=0; i<parts1.length && i<parts2.length; i++){
	    if(parts1[i].equals(parts2[i]))
		ret = ret + parts1[i];
	}
	return ret;
    }
    */

}
